/**
   Examples from three algorithms textbooks.
*/
public class TestEditDistance_1
{
   public static void main(String[] args)
   {
      EditDistance_v3.printTable = true;
      EditDistance_v3.decodeTable = true;

      System.out.println();

      // "The Algorithm Design Manual", 3rd Edition, page 319.
      String s = "thou shalt";
      String t = "you should";
      System.out.println(s + ", " + t + ", " + EditDistance_v2.edit(s, t));
      System.out.println(s + ", " + t + ", " + EditDistance_v3.edit(s, t));

      System.out.println();

      // "Algorithms", by Dasgupta, Papadimitriou & Vazirani, page 176.
      // https://people.eecs.berkeley.edu/~vazirani/algorithms/chap6.pdf#page=8
      s = "exponential";
      t = "polynomial";
      System.out.println(s + ", " + t + ", " + EditDistance_v2.edit(s, t));
      System.out.println(s + ", " + t + ", " + EditDistance_v3.edit(s, t));

      System.out.println();

      // "Algorithms", by Jeff Erickson, page 115.
      // https://jeffe.cs.illinois.edu/teaching/algorithms/book/03-dynprog.pdf#page=19
      s = "altruistic";
      t = "algorithm";
      System.out.println(s + ", " + t + ", " + EditDistance_v2.edit(s, t));
      System.out.println(s + ", " + t + ", " + EditDistance_v3.edit(s, t));
   }
}
