
import java.util.Arrays;

/**
   Test any one of the three versions of LCS.
*/
public class Test_LCS
{
   public static void main(String[] args)
   {
      LCS.printTable = true;

      int[] a = {1, 2, 3, 4, 5, 6};
      int[] b = {1, 2, 3, 4, 5, 6};

      System.out.println("a[] = " + Arrays.toString(a));
      System.out.println("b[] = " + Arrays.toString(b));

      // Compute the length of the longest common subsequence.
      int length = LCS.lcs3(a, b, a.length, b.length);  // top-down
                   LCS.lcs2(a, b, a.length, b.length);  // bottom-up
      System.out.printf("lcs(a, b) = %d.\n", length);

      System.out.println();

      a = new int[]{1, 2, 3, 4, 5, 6};
      b = new int[]{1, 2, 3, 4, 5, 6, 7};

      System.out.println("a[] = " + Arrays.toString(a));
      System.out.println("b[] = " + Arrays.toString(b));

      // Compute the length of the longest common subsequence.
      length = LCS.lcs3(a, b, a.length, b.length);  // top-down
               LCS.lcs2(a, b, a.length, b.length);  // bottom-up
      System.out.printf("lcs(a, b) = %d.\n", length);

      a = new int[]{1, 2, 3, 4, 5, 6, 7};
      b = new int[]{1, 2, 3, 4, 5, 6};

      System.out.println("a[] = " + Arrays.toString(a));
      System.out.println("b[] = " + Arrays.toString(b));

      // Compute the length of the longest common subsequence.
      length = LCS.lcs3(a, b, a.length, b.length);  // top-down
               LCS.lcs2(a, b, a.length, b.length);  // bottom-up
      System.out.printf("lcs(a, b) = %d.\n", length);

      a = new int[]{1, 2, 3, 4, 4, 4, 4, 6, 7, 8, 9};
      b = new int[]{1, 2, 3, 5, 5, 5, 5, 6, 7, 8, 9};

      System.out.println("a[] = " + Arrays.toString(a));
      System.out.println("b[] = " + Arrays.toString(b));

      // Compute the length of the longest common subsequence.
      length = LCS.lcs3(a, b, a.length, b.length);  // top-down
      System.out.printf("lcs(a, b) = %d.\n", length);
   }
}
